<template>
  <div class="app-container">
    <div class="filter-container">
      <!-- <el-date-picker
        v-model="searchDate"
        :picker-options="pickerOptions"
        class="filter-item"
        type="daterange"
        format="yyyy年MM月dd日"
        value-format="yyyy-MM-dd"
        align="left"
        unlink-panels
        range-separator="至"
        start-placeholder="开始日期"
        end-placeholder="结束日期"/> -->
      <el-select
        v-model="groupid"
        class="filter-item"
        filterable
        clearable
        placeholder="请选择所属坐席组">
        <el-option
          v-for="item in seatOptions"
          :key="item.F_ZXZID"
          :label="item.F_ZXZName"
          :value="item.F_ZXZID"/>
      </el-select>
      <el-input v-model="keyword" placeholder="请输入关键字" class="filter-item"/>
      <el-button type="primary" class="filter-item" icon="el-icon-search" @click="btn_search">搜索</el-button>
      <el-button v-permission="'HY_add'" type="primary" class="filter-item" icon="el-icon-plus" @click="btn_add">添加</el-button>
    </div>

    <el-table v-loading="loading" :data="dataLists" border stripe>
      <el-table-column type="index" label="编号" align="center" fixed width="80"/>
      <el-table-column prop="F_DutyNumber" label="值班电话" align="center" min-width=""/>
      <el-table-column prop="F_Group" label="组别" align="center" min-width=""/>
      <el-table-column prop="F_Remark" label="说明" align="center" min-width=""/>
      <el-table-column prop="F_ZBTime" label="值班时间" align="center" min-width=""/>
      <el-table-column prop="F_LastModifyOn" label="最后修改时间" align="center" min-width=""/>
      <el-table-column prop="F_CreateBy" label="创建人" align="center" min-width=""/>
      <el-table-column prop="F_CreateOn" label="创建时间" align="center" min-width=""/>
      <el-table-column label="操作" width="160" align="center" class-name="oparate_btn" fixed="right">
        <template slot-scope="scope">
          <el-button v-permission="'HY_edit'" size="mini" plain type="primary" @click="btn_edit(scope.row.F_ID)">编辑</el-button>
          <el-button v-permission="'HY_delete'" size="mini" plain type="danger" @click="btn_delete(scope.row.F_ID)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="pageParams.total > 0"
      :total="pageParams.total"
      :pageindex.sync="pageParams.pageindex"
      :pagesize.sync="pageParams.pagesize"
      class="pagination"
      @pagination="getList" />
  </div>
</template>

<script>

import { getSeatGroupLists } from '@/api/systemSetup/roleSetting/seatGroup'
import { getDutyLists, deleteDuty } from '@/api/telCall/duty'
import addOrEditDuty from './addOrEditDuty'
import { pickerOptions } from '@/utils'
import { getSeatGroup } from '@/api/commonAPI'
import Pagination from '@/components/Pagination' // 对el-pagination 二次封装

export default {
  name: 'Duty',
  components: {
    Pagination
  },
  filters: {

  },
  data() {
    return {
      loading: false,
      keyword: '',
      searchDate: '',
      pickerOptions,
      pageParams: {
        pageindex: 1, // 当前第几页
        pagesize: Number(this.$store.getters.serverConfig.PAGESIZE), // 每页几条数据
        total: 0 // 总共多少数据
      },
      dataLists: [], // 列表数据
      seatOptions: [],
      groupid: ''
    }
  },
  created() {
    this.getSeatGroupSelects()
    this.getList()
    document.onkeyup = (e) => {
      if (e.keyCode === 13) {
        this.getList()
      }
    }
  },
  methods: {
    getList() {
      this.loading = true
      return new Promise(resolve => {
        const params = {
          pageindex: this.pageParams.pageindex, // 第几页
          pagesize: this.pageParams.pagesize, // 每页几条信息
          key: this.keyword.trim(),
          groupid: this.groupid,
        }
        getDutyLists(params).then(response => {
          this.loading = false
          if (response.state.toLowerCase() === 'success') {
            this.pageParams.total = response.data.Totals
            this.dataLists = response.data.Rows
          }
        })
        resolve()
      })
    },
    btn_search() {
      this.pageParams.pageindex = 1
      this.getList()
    },
    btn_add() {
      this.$layer.iframe({
        content: {
          content: addOrEditDuty, // 传递的组件对象
          parent: this, // 当前的vue对象
          data: { 'rowid': ''}// props//该方法会自动添加一个key为layerid的值， 该值为创建层的id， 可以直接使用
        },
        area: ['40%', '40%'],
        title: '添加值班电话号码'
      })
    },
    btn_edit(editId) {
      this.$layer.iframe({
        content: {
          content: addOrEditDuty, // 传递的组件对象
          parent: this, // 当前的vue对象
          data: { 'rowid': editId }// props
        },
        area: ['40%', '40%'],
        title: '编辑值班电话号码'
      })
    },
    btn_delete(editId) {
      this.$confirm('您确定要删除此值班电话号码吗?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        deleteDuty(editId).then(response => {
          if (response.state.toLowerCase() === 'success') {
            this.getList()
            this.$message.success('删除成功!')
          }
        })
      }).catch(() => {
        this.$message.info('已取消删除')
      })
    },
    // 获取坐席组下拉数据
    getSeatGroupSelects() {
      return new Promise(resolve => {
        getSeatGroupLists().then(response => {
          if (response.state.toLowerCase() === 'success') {
            this.seatOptions = response.data.Rows
          }
        })
        resolve()
      })
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>

</style>
